module Rakka.Wiki.Interpreter.Trackback
    ( interpreters
    )
    where

import           Rakka.Page
import           Rakka.SystemConfig
import           Rakka.Wiki
import           Rakka.Wiki.Interpreter


interpreters :: [Interpreter]
interpreters = [ trackbackURLInterp
               , trackbacksInterp
               ]


trackbackURLInterp :: Interpreter
trackbackURLInterp
    = InlineCommandInterpreter {
        iciName = "trackbackURL"
      , iciInterpret
          = \ ctx _ -> do BaseURI baseURI <- getSysConf (ctxSysConf ctx)
                          let uri = mkAuxiliaryURI baseURI ["trackback"] (ctxPageName ctx)
                          return $ ExternalLink uri (Just "Trackback URL")
      }


trackbacksInterp :: Interpreter
trackbacksInterp 
    = BlockCommandInterpreter {
        bciName = "trackbacks"
      , bciInterpret
          = \ _ _ -> return $ Div [("class", "trackbacks")] []
      }
